/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "plparser.override"
#define NO_IMPORT_PYGOBJECT
#include "pygobject.h"
#include "totem-pl-parser.h"
#include "totem-pl-parser-builtins.h"
#include <gtk/gtk.h>
#include <glib.h>
#line 15 "plparser.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkTreeModel_Type;
#define PyGtkTreeModel_Type (*_PyGtkTreeModel_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject G_GNUC_INTERNAL PyTotemPlParser_Type;

#line 28 "plparser.c"



/* ----------- TotemPlParser ----------- */

static int
_wrap_totem_pl_parser_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char* kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     ":totem.plparser.Parser.__init__",
                                     kwlist))
        return -1;

    pygobject_constructv(self, 0, NULL);
    if (!self->obj) {
        PyErr_SetString(
            PyExc_RuntimeError, 
            "could not create totem.plparser.Parser object");
        return -1;
    }
    return 0;
}

#line 21 "plparser.override"

typedef struct {
	PyObject *func;
	PyObject *data;
	gboolean has_error;
} PyPlParserIterFuncData;

static void
_pl_parser_iter_func (GtkTreeModel *model, GtkTreeIter *iter, char **uri, char **title,
		      gpointer user_data)
{
	PyObject *args = NULL;
	PyObject *result = NULL;
	char *tmp_uri = NULL, *tmp_title = NULL;
	PyPlParserIterFuncData *data = user_data;

	if (data->has_error)
		return;

	if (data->data)
		args = Py_BuildValue ("(NNO)",
				      pygobject_new((GObject *)model),
				      pyg_boxed_new(GTK_TYPE_TREE_ITER, iter, TRUE, TRUE),
				      data->data);
	else
		args = Py_BuildValue ("(NN)",
				      pygobject_new((GObject *)model),
				      pyg_boxed_new(GTK_TYPE_TREE_ITER, iter, TRUE, TRUE));
	result = PyEval_CallObject (data->func, args);
	Py_DECREF (args);
	
	if (result == NULL) {
		data->has_error = TRUE;
		return;
	}
	  /* ?! */
	/* PyObject_Print (result, stdout, 0); */

	if (PyString_Check (result)) {
		tmp_uri = PyString_AsString (result);
		if (tmp_uri == NULL) {
			PyErr_SetString (PyExc_TypeError,
					 "Callback function must return one"
					 " string or a tuple of two strings.");
			data->has_error = TRUE;
		}
	} else if (!PyTuple_Check (result) ||
		   !PyArg_ParseTuple (result, "ss", &tmp_uri, &tmp_title))
	{
		PyErr_SetString (PyExc_TypeError,
				 "Callback function must return one "
				 "string or a tuple of two strings.");
		data->has_error = TRUE;
	}
	
	/* g_strdup handles NULL case for us */
	*uri = g_strdup (tmp_uri);
	*title = g_strdup (tmp_title);
	
	Py_DECREF (result);
}

static PyObject *
_wrap_totem_pl_parser_write (PyGObject *self, PyObject *args, PyObject *kwargs)
{
	static char *kwlist[] = {"model", "iter_func", "output", "type", NULL};
	PyGObject *model;
	char *output;
	TotemPlParserType type;
	GError *error = NULL;
	PyPlParserIterFuncData data = {0, };
	
	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!Osi|O:Parser.write",
					 kwlist, &PyGtkTreeModel_Type, &model,
					 &data.func, &output, &type, &data.data))
		return NULL;
	/* verify arguments' integrity */
	if (!PyCallable_Check (data.func)) {
		PyErr_SetString (PyExc_TypeError, "iter_func must be callable");
		return NULL;
	}
	if (!totem_pl_parser_write (TOTEM_PL_PARSER(self->obj),
	                            GTK_TREE_MODEL(model->obj),
	                            _pl_parser_iter_func,
	                            output,type, &data, &error))
	{
		/* return an GError */
		pyg_error_check(&error);
		return NULL;
	}
	if (data.has_error)
		return NULL;
	Py_INCREF(Py_None);
	return Py_None;
}
#line 150 "plparser.c"


static PyObject *
_wrap_totem_pl_parser_add_ignored_scheme(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "scheme", NULL };
    char *scheme;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:TotemPlParser.add_ignored_scheme", kwlist, &scheme))
        return NULL;
    
    totem_pl_parser_add_ignored_scheme(TOTEM_PL_PARSER(self->obj), scheme);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_totem_pl_parser_parse(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "url", "fallback", NULL };
    char *url;
    int fallback;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"si:TotemPlParser.parse", kwlist, &url, &fallback))
        return NULL;
    
    ret = totem_pl_parser_parse(TOTEM_PL_PARSER(self->obj), url, fallback);
    
    return pyg_enum_from_gtype(TOTEM_TYPE_PL_PARSER_RESULT, ret);
}

static const PyMethodDef _PyTotemPlParser_methods[] = {
    { "write", (PyCFunction)_wrap_totem_pl_parser_write, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "add_ignored_scheme", (PyCFunction)_wrap_totem_pl_parser_add_ignored_scheme, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "parse", (PyCFunction)_wrap_totem_pl_parser_parse, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyTotemPlParser_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "totem.plparser.Parser",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyTotemPlParser_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_totem_pl_parser_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

const PyMethodDef pyplparser_functions[] = {
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pyplparser_add_constants(PyObject *module, const gchar *strip_prefix)
{
  pyg_enum_add(module, "ParserResult", strip_prefix, TOTEM_TYPE_PL_PARSER_RESULT);
  pyg_enum_add(module, "ParserType", strip_prefix, TOTEM_TYPE_PL_PARSER_TYPE);
  pyg_enum_add(module, "ParserError", strip_prefix, TOTEM_TYPE_PL_PARSER_ERROR);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pyplparser_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        _PyGObject_Type = (PyTypeObject *)PyObject_GetAttrString(module, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return ;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        _PyGtkTreeModel_Type = (PyTypeObject *)PyObject_GetAttrString(module, "TreeModel");
        if (_PyGtkTreeModel_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name TreeModel from gtk");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtk");
        return ;
    }


#line 293 "plparser.c"
    pygobject_register_class(d, "TotemPlParser", TOTEM_TYPE_PL_PARSER, &PyTotemPlParser_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(TOTEM_TYPE_PL_PARSER);
}
